<template>
  <div class="container mx-auto p-4">
    <!-- Welcome Message -->
    <div v-if="user">
      <h2>Welcome, {{ user.username }}!</h2>
      <p>Your wallet address: {{ user.walletAddress }}</p>
      <button @click="logout" class="bg-red-500 text-white px-4 py-2 rounded">Logout</button>
    </div>

    <!-- UPBOARD -->
    <div class="flex justify-between items-center mb-6">
      <!-- DASHBOARD TITLE -->
      <div class="flex justify-between items-center text-blue-300 text-2xl font-bold">
        <div class="object-contain">
          <!-- Your SVG icon -->
          <svg
            xmlns="http://www.w3.org/2000/svg"
            fill="none"
            viewBox="0 0 24 24"
            stroke-width="1.5"
            stroke="currentColor"
            class="size-6"
          >
            <!-- SVG Path -->
            <path
              stroke-linecap="round"
              stroke-linejoin="round"
              d="M12 21a9.004 9.004 0 0 0 8.716-6.747M12 21a9.004 9.004 0 0 1-8.716-6.747M12 21c2.485 0 4.5-4.03 4.5-9S14.485 3 12 3m0 18c-2.485 0-4.5-4.03-4.5-9S9.515 3 12 3m0 0a8.997 8.997 0 0 1 7.843 4.582M12 3a8.997 8.997 0 0 0-7.843 4.582m15.686 0A11.953 11.953 0 0 1 12 10.5c-2.998 0-5.74-1.1-7.843-2.918m15.686 0A8.959 8.959 0 0 1 21 12c0 .778-.099 1.533-.284 2.253m0 0A17.919 17.919 0 0 1 12 16.5c-3.162 0-6.133-.815-8.716-2.247m0 0A9.015 9.015 0 0 1 3 12c0-1.605.42-3.113 1.157-4.418"
            />
          </svg>
        </div>

        <h1 class="text-blue-300 text-2xl font-bold px-4">SpaceDAO STM</h1>
      </div>

      <!-- REFRESH DATA BUTTON -->
      <Button @click="refreshData" class="flex font-semibold items-center">
        Refresh Data
      </Button>
    </div>

    <!-- LATEST ACTIVITIES BOARD -->
    <div class="hidden md:grid md:grid-cols-3 gap-2 mb-6">
      <!-- CARD 1 - SATELLITES DATA COUNT -->
      <Card>
        <CardHeader class="flex flex-row items-center justify-between space-y-0 pb-2">
          <CardTitle class="text-sm font-medium">Total Satellites</CardTitle>
        </CardHeader>
        <CardContent>
          <div class="text-2xl font-bold">{{ latestActivities.satellitesData }}</div>
        </CardContent>
      </Card>

      <!-- CARD 2 - SPATIAL DATA COUNT -->
      <Card>
        <CardHeader class="flex flex-row items-center justify-between space-y-0 pb-2">
          <CardTitle class="text-sm font-medium">Latest Spatial Data Update</CardTitle>
        </CardHeader>
        <CardContent>
          <div class="text-2xl font-bold">{{ latestActivities.spatialData }}</div>
        </CardContent>
      </Card>

      <!-- CARD 3 - COLLISION DATA COUNT -->
      <Card>
        <CardHeader class="flex flex-row items-center justify-between space-y-0 pb-2">
          <CardTitle class="text-sm font-medium">New Potential Detected Collisions</CardTitle>
        </CardHeader>
        <CardContent>
          <div class="text-2xl font-bold">{{ latestActivities.collisionData }}</div>
        </CardContent>
      </Card>
    </div>

    <!-- MAINBOARD -->
    <div class="flex flex-row justify-between items-start overflow-y-auto gap-2 p-2">
      <!-- LEFT-SIDE : GLOBE VISUALIZATION -->
      <div class="w-1/3 md:w-1/2 h-96 mt-2 lg:mb-0">
        <!-- GLOBE -->
        <div class="h-52">
          <GlobeView @cdm-hovered="updateSelectedCDM" :latestActivities="latestActivities" />
        </div>
        <!-- GLOBE LEGEND -->
        <div><GlobeLegend /></div>
      </div>

      <!-- RIGHT-SIDE : CDM INFOS -->
      <div class="w-2/3 h-96 md:px-0">
        <CDMInfos :selectedCDM="selectedCDM" :latestActivities="latestActivities" />
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
/* Libraries */
import { ref, computed } from 'vue';
import { useAuth } from 'vue-auth3';
import { useRouter } from 'vue-router';

/* Components */
import type { CDMData, LatestActivities } from '@/types/types';
import GlobeView from '@/components/HomeContent/GlobeCDMView.vue';
import GlobeLegend from '@/components/HomeContent/GlobeLegend.vue';
import CDMInfos from '@/components/HomeContent/DatasCDMView.vue';
import Button from '@/components/UI/button/Button.vue';
import Card from '@/components/UI/card/Card.vue';
import CardHeader from '@/components/UI/card/CardHeader.vue';
import CardTitle from '@/components/UI/card/CardTitle.vue';
import CardContent from '@/components/UI/card/CardContent.vue';



/* State Variables */
// State 1 - selectedCDM
const selectedCDM = ref<CDMData | null>(null);

// State 2 - latest activities
const latestActivities = ref<LatestActivities>({
  spatialData: `${Math.floor(Math.random() * 60)} minutes ago`,
  collisionData: Math.floor(Math.random() * 10),
  satellitesData: Math.floor(Math.random() * 100),
});

/* Methods */
// Method 1 - updateSelectedCDM
const updateSelectedCDM = (cdm: CDMData) => {
  selectedCDM.value = cdm;
};

// Method 2 - refreshData
const refreshData = () => {
  latestActivities.value = {
    spatialData: `${Math.floor(Math.random() * 60)} minutes ago`,
    collisionData: Math.floor(Math.random() * 10),
    satellitesData: Math.floor(Math.random() * 100),
  };
};
</script>

<style scoped>
/* Your existing styles */
</style>
